import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import java.lang.Exception;
/**
 * A collection that contains no duplicate elements. More formally, sets contain no pair of elements
 * e1 and e2 such that e1.equals(e2), and at most one null element. As amplied by its name, this interface
 * models
 * @param <E>
 */
public class MySet<E>{

    private int size;
    private Object[] elements;

    public MySet() {
        elements = new Object[10];
        size = 0;
    }

    public int size() {
        return size;
    }

    /**
     * Adds the specified element to this set if it is not already present (optional operation).
     * @param e
     */

    public boolean add(E e){
        if(contains(e)){
            return false;
        }
        for(int i = 0; i < elements.length; i++) {
            if (elements[i] == null) {
                elements[i] = e;
                break;
            }
        }
        return true;
    }

    public void clear() {
        if (size > 0)
            elements[size] = 0;
    }

    public boolean contains(E e) {
        for (Object o : elements) {
            if (o != null && o.equals(e)) {
                return true;
            }
        }
        return false;
    }

    public boolean equals(MySet<E> e) {
        if (elements.length != e.size()) {
            return false;
        }
        for(int i = 0; i < e.size; i++) {
            if (!e.elements[i].equals(elements[i])) {
                return false;
            }
        }
        return true;
    }

    public int hashCode() {
        return elements.hashCode();
    }

    public boolean isEmpty() {
        for (int i = 0; i < elements.length; i++){
            if(elements[i] != null)
                return false;
            }
            return true;
        }

    public Iterator<E> iterator() {
        return Arrays.asList((E)elements).iterator();
    }

    public boolean remove(E e) {
        for(int i = 0; i < elements.length; i++) {
            if(elements[i] != e) {
                return false;
            }else{
                elements[i] = null;
            }
        }
        return true;
    }

    public E[] toArray() {
        return (E[])elements;
    }
}