import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class MyArrayListTest {

    private MyArrayList<Integer> myArrList;

    @Before
    public void setUp() { myArrList = new MyArrayList<>(); }

    @Test
    public void testAdd() {
        Integer expected = 1;
        myArrList.add(expected);
        Integer actual = myArrList.size();
        assertEquals(expected, actual);
    }

    @Test
    public void testSet() {
        myArrList.add(3);
        Integer expected = 27;
        myArrList.set(0, 27);
        Integer actual = myArrList.get(0);
        assertEquals(expected, actual);
    }

    @Test
    public void testGet() {
        Integer expected = 27;
        myArrList.add(expected);
        Integer actual = myArrList.get(0);
        assertEquals(expected, actual);
    }


    @Test
    public void testClear() {
        Integer expectedSize = 0;
        myArrList.clear();
        Integer actualSize = myArrList.size();
        assertEquals(expectedSize, actualSize);
    }

    @Test
    public void testIsEmpty() {
        Boolean expected = true;
        myArrList.size();
        boolean isEmpty = myArrList.isEmpty();
        Assert.assertTrue(true);
    }

    @Test
    public void testContains() {
        Boolean expected = false;
        myArrList.set(1, 34);
        myArrList.contains(4);
        Assert.assertFalse(false);
    }

    @Test
    public void testRemove() {
        Integer expected = 69;
        myArrList.set(3, 69);
        Integer actual = myArrList.remove(3);
        assertEquals(expected, actual);
    }

    @Test
    public void testIndexOf() {
        Integer expected = 7;
        myArrList.set(7, 27);
        Integer actual = myArrList.indexOf(27);
        assertEquals(expected, actual);
    }
}