import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.util.Iterator;

import static org.junit.Assert.*;

public class MySetTest {

    @Test
    public void testAdd() {
        MySet<Integer> mySet = new MySet<>();
        assertTrue(mySet.add(2));
    }


    @Test
    public void testClear() {
        MySet<Integer> mySet = new MySet<>();
        Integer expectedSize = 0;
        mySet.clear();
        Integer actualSize = mySet.size();
        assertEquals(expectedSize, actualSize);
    }

    @Test
    public void testEquals() {
        MySet<Integer> mySet = new MySet<>();
        mySet.add(4);
        MySet<Integer> mySet2 = new MySet<>();
        mySet.add(4);
        boolean expected = true;
        expected = mySet.equals(mySet2);
        boolean actual = mySet.equals(mySet2);
        assertEquals(expected, actual);
    }

    @Test
    public void testHashCode() {
        MySet<Integer> mySet = new MySet<>();
        int expected = mySet.hashCode();
        assertEquals(expected, mySet.hashCode());
    }

    @Test
    public void testIsEmpty() {
        MySet<Integer> mySet = new MySet<>();
        assertEquals(mySet.size(), 0);
    }

    @Test
    public void testIterator() {
        MySet<Integer> mySet = new MySet<>();
        mySet.add(3);
        mySet.add(7);
        mySet.add(1);
        Iterator<Integer> expected  = mySet.iterator();
        assertNotNull(expected);
    }

    @Test
    public void testRemove() {
        MySet<Integer> mySet = new MySet<>();
        mySet.add(4);
        mySet.remove(4);
        assertFalse(mySet.contains(4));
    }

    @Test
    public void testToArray() {
        MySet<Integer> mySet = new MySet<>();
        mySet.add(1);
        mySet.add(2);
        mySet.add(3);
        mySet.toArray();
        Integer[] asdf = new Integer[10];
        asdf[0] = 1;
        asdf[1] = 2;
        asdf[2] = 3;
        assertEquals(mySet.toArray(), asdf);
    }
}